##  for PCLinuxOS  ##

Name:    marisa
Summary: Static and spece-efficient trie data structure library
Version: 0.2.4
Release: 3.nora19
Group:   System/Libraries
License: BSD or LGPL
URL:     https://code.google.com/p/marisa-trie/
Source0: https://marisa-trie.googlecode.com/files/%{name}-%{version}.tar.gz

BuildRequires: swig
BuildRequires: perl-devel
BuildRequires: %{_lib}python-devel
BuildRequires: %{_lib}python3-devel
BuildRequires: ruby-devel

%description
Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static and space-efficient trie data structure.
And libmarisa is a C++ library to provide an implementation of MARISA.
Also, the package of libmarisa contains a set of command line tools for building and operating a MARISA-based dictionary.

A MARISA-based dictionary supports not only lookup but also reverse lookup, common prefix search and predictive search.


%package devel
Summary: Development files for %{name}
Group:   Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for developing applications that use %{name}.


%package tools
Summary: Tools for %{name}
Group:   Development/Tools
Requires: %{name} = %{version}-%{release}

%description tools
The %{name}-tools package contains tools for developing applications that use %{name}.


%package perl
Summary: Perl language binding for marisa
Group:   Development/Libraries
Requires: %{name} = %{version}-%{release}

%description perl
Perl language binding for marisa


%package python
Summary: Python language binding for marisa
Group:   Development/Libraries
Requires: %{name} = %{version}-%{release}

%description python
Python language binding for marisa


%package python3
Summary: Python 3 language binding for marisa
Group:   Development/Libraries
Requires: %{name} = %{version}-%{release}

%description python3
Python 3 language binding for marisa


%package ruby
Summary: Ruby language binding for marisa
Group:   Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: ruby

%description ruby
Ruby language binding for groonga

# ---------------------------------------------------------

%prep
%setup -q


%build
%configure2_5x --disable-static

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make_build

# build Perl bindings
pushd bindings/perl
perl Makefile.PL INC="-I%{_builddir}/%{name}-%{version}/lib" LIBS="-L%{_builddir}/%{name}-%{version}/lib/.libs"
%make_build
popd

# build Python bindings
# Regenerate Python bindings
make --directory=bindings swig-python

pushd bindings/python
python setup.py build_ext --include-dirs="%{_builddir}/%{name}-%{version}/lib" --library-dirs="%{_builddir}/%{name}-%{version}/lib/.libs"
python setup.py build

python3 setup.py build_ext --include-dirs="%{_builddir}/%{name}-%{version}/lib" --library-dirs="%{_builddir}/%{name}-%{version}/lib/.libs"
python3 setup.py build
popd

# build Ruby bindings
# Regenerate ruby bindings
pushd bindings
make swig-ruby
popd

pushd bindings/ruby
ruby extconf.rb --with-opt-include="%{_builddir}/%{name}-%{version}/lib" --with-opt-lib="%{_builddir}/%{name}-%{version}/lib/.libs" --vendor
%make_build
popd


%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

# install Perl bindings
pushd bindings/perl
%makeinstall_std
chmod 0755 $RPM_BUILD_ROOT%{perl_sitearch}/auto/marisa/marisa.so
chmod 0644 $RPM_BUILD_ROOT%{perl_sitearch}/marisa.pm
rm -f $RPM_BUILD_ROOT%{perl_sitearch}/sample.pl
popd

# install Python bindings
pushd bindings/python
python setup.py install --root="$RPM_BUILD_ROOT"
python3 setup.py install --root="$RPM_BUILD_ROOT"
popd

# install Ruby bindings
pushd bindings/ruby
%makeinstall_std
popd

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
find $RPM_BUILD_ROOT -name 'perllocal.pod' -exec rm -f {} ';'


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%doc docs/* AUTHORS COPYING README
%{_libdir}/*.so.*

%files devel
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%files tools
%{_bindir}/marisa*

%files perl
%{perl_sitearch}/*

%files python
%{python_sitearch}/*

%files python3
%{python3_sitearch}/*

%files ruby
%{_libdir}/ruby/vendor_ruby/*


%changelog
* Fri Feb 01 2019 tomcat <> 0.2.4-3.nora19
- build with ruby-2.6.1
- provide Python 3 subpackage
